#define MYKIND 8

#if MYKIND == 4 /* single */

#define MYCMPLX    CMPLX
#define MYREAL     REAL
#define MY_COMPLEX_TYPE MPI_COMPLEX

/* LAPACK */
#define NRM2    SCNRM2
#define GEMV     CGEMV
#define GERU     CGERU
#define GEMM     CGEMM
#define TRTRS    CTRTRS
#define GEQP3    CGEQP3
#define GETRF    CGETRF
#define LASWP    CLASWP
#define GESVD    CGESVD
#define TRMM     CTRMM
#define GEQLF    CGEQLF
#define UNMQL    CUNMQL
#define GELQF    CGELQF
#define UNMLQ    CUNMLQ

/* SCALAPACK */
#define PGEMM   PCGEMM
#define PGEMR2D PCGEMR2D
#define PGEQPF  PCGEQPF
#define PTRTRS  PCTRTRS
#define PGETRF  PCGETRF
#define PLAPIV  PCLAPIV
#define PGEADD  PCGEADD
#define PTRSM   PCTRSM
#define PLANGE  PCLANGE
#define GEBS2D   CGEBS2D
#define GEBR2D   CGEBR2D

/* FFTW3 */
#define PLAN_MANY dfftwf_plan_many_dft
#define EXECUTE   dfftwf_execute
#define DESTROY   dfftwf_destroy_plan



#elif MYKIND == 8 /* double */

#define MYCMPLX    DCMPLX
#define MYREAL     DBLE
#define MY_COMPLEX_TYPE MPI_DOUBLE_COMPLEX

/* LAPACK */
#define NRM2    DZNRM2
#define GEMV     ZGEMV
#define GERU     ZGERU
#define GEMM     ZGEMM
#define TRTRS    ZTRTRS
#define GEQP3    ZGEQP3
#define GETRF    ZGETRF
#define LASWP    ZLASWP
#define GESVD    ZGESVD
#define TRMM     ZTRMM
#define GEQLF    ZGEQLF
#define UNMQL    ZUNMQL
#define GELQF    ZGELQF
#define UNMLQ    ZUNMLQ

/* SCALAPACK */
#define PGEMM   PZGEMM
#define PGEMR2D PZGEMR2D
#define PGEQPF  PZGEQPF
#define PTRTRS  PZTRTRS
#define PGETRF  PZGETRF
#define PLAPIV  PZLAPIV
#define PGEADD  PZGEADD
#define PTRSM   PZTRSM
#define PLANGE  PZLANGE
#define GEBS2D   ZGEBS2D
#define GEBR2D   ZGEBR2D

/* FFTW3 */
#define PLAN_MANY dfftw_plan_many_dft
#define EXECUTE   dfftw_execute
#define DESTROY   dfftw_destroy_plan
  
#endif /* end */
