#include "header.h"

program tsolver
  use toephssrs
  implicit none

  integer           :: unit, n, ncol, maxit, nrhs
  character(len=32) :: string, name, f1, f2
  real(4)           :: tol, tolit, t1, t2
  
  complex(MYKIND),allocatable   :: data(:,:), cv(:), rv(:), b(:,:), x(:,:)

  ! ./main.out 'filename' n nrhs tol ncol maxit tolit
  
  call getarg(1,string)
  read(string,*) name
  call getarg(2,string)
  read(string,*) n
  call getarg(3,string)
  read(string,*) nrhs
  call getarg(4,string)
  read(string,*) tol
  call getarg(5,string)
  read(string,*) ncol
  call getarg(6,string)
  read(string,*) maxit
  call getarg(7,string)
  read(string,*) tolit

  allocate(data(n,nrhs+2),cv(n),rv(n),b(n,nrhs),x(n,nrhs))
  
  unit=99
  open(unit,file=name)
  read(unit,*) data
  close(unit)

  cv=data(:,1)
  rv=data(:,2)
  b=data(:,3:2+nrhs)

  f1='(a20,i10)'
  f2='(a20,e10.3)'
  
  write(*,*) '------------------------------------'
  write(*,*) 'Parameters:'
  write(*,f1) 'MATRIX SIZE=',n
  write(*,f1) 'NRHS=',nrhs
  write(*,f2) 'HSS COMPR TOL=',tol
  write(*,f1) 'EST HSS RANK=',ncol
  write(*,f1) 'MAXIT=',maxit
  write(*,f2) 'TOL FOR ITER=',tolit
  write(*,*) '------------------------------------'

  call cpu_time(t1)
  call toep_hssrs(cv,rv,n,b,x,nrhs,ncol,tol,maxit,tolit)
  call cpu_time(t2)

  write(*,*) 'Elapsed CPU time(s):',t2-t1
  
  open(unit,file='x.dat')
  write(unit,*) x
  close(unit)

  write(*,*) 'Solution saved in x.dat'
  
end program tsolver
